#include "StdAfx.h"
#include ".\ircontrol.h"

int IRControl::Init(char ComPort[])
{
	DCB dcb;
	COMMCONFIG commconfig;
	DWORD dwErr;

	if ( ComPort != NULL ) {
		strncpy(cIRCom,ComPort, 4);
		cIRCom[4]='\0';
		hIRCom = CreateFile(cIRCom, GENERIC_READ,	0,
							 //NULL, OPEN_EXISTING,	FILE_ATTRIBUTE_NORMAL, NULL);
							 NULL, OPEN_EXISTING, NULL, NULL);
		if (hIRCom == INVALID_HANDLE_VALUE) { return ERR_OPENPORT; }

		memset(&dcb,0,sizeof(DCB));

		// Set the dcb structure
		{
			dcb.DCBlength=sizeof(DCB);
			dcb.BaudRate = CBR_9600;
			dcb.fBinary  = TRUE;
			dcb.fParity  = FALSE;
			dcb.fOutxCtsFlow = FALSE;
			dcb.fOutxDsrFlow = FALSE;
			dcb.fDtrControl = DTR_CONTROL_ENABLE;
			dcb.fDsrSensitivity = FALSE;
			dcb.fTXContinueOnXoff = TRUE;
			dcb.fOutX = TRUE;
			dcb.fInX = TRUE;
			dcb.fErrorChar = FALSE;
			dcb.fNull = FALSE;
			dcb.fRtsControl = RTS_CONTROL_ENABLE;
			dcb.fAbortOnError = TRUE;
			//dcb.fDummy2 =;
			//dcb.wReserved =;
			dcb.XonLim = 2048;
			dcb.XoffLim = 512;
			dcb.ByteSize = 8;
			dcb.Parity = NOPARITY;
			dcb.StopBits = ONESTOPBIT;
			dcb.XonChar = 17;
			dcb.XoffChar = 19;
			//dcb.ErrorChar = ;
			dcb.EofChar = EOF;
			//dcb.EvtChar = ;
			//dcb.wReserved1 =;
		}

		dwErr=SetCommState(hIRCom,&dcb);
//		GetCommState(hIRCom,&dcb);
//		tmp=sizeof(COMMCONFIG);
//		GetCommConfig(hIRCom,&commconfig,&tmp);

		return ERR_NO_ERROR;
	} else {
		return ERR_INVALID_PORT;
	}
}

int IRControl::Read(char buf[])
{
	DWORD dwCount=0;
	DWORD dwErr;
	DWORD dwRetErr;

	buf[0]='\0';

	if ( dwErr=ReadFile(hIRCom,buf,1,&dwCount,NULL) ) {
		buf[dwCount]='\0';
		return dwErr;
	} else {
		dwRetErr=GetLastError();
		return ERR_READ;
	}
}

IRControl::IRControl(void)
{
}

IRControl::~IRControl(void)
{
}
