#include <Windows.h>
#pragma once
/*
	How to use this class(in C++):

		RCMotion RCDev;
		RCDev.RCMInit("COM?");
		RCDev.WheelInit();

		// forward with speed 0x0001F77E 
			RCDev.WheelSetVelocity(0x0001F77E);
			RCDev.WheelUpdate();
		// turn left(+ve) or right(-ve) with speed 0x0001F77E
			RCDev.WheelSetTurn(0x0001F77E);
			RCDev.WheelUpdate();
	
	New function set could be created with four different overloading functions:
		SendCmd(...)
	
	Two special variable for debuggin:

		nosend=0; // disable(1) from sending command the COM port
		debug=0;  // enable(1) dumping of command sending to COM port

	Creator: Yau Lam Yiu
	Version: 0.5

	Please send any comment or bug report to yiu@cs.ust.hk with "RCMotion comment"
	as the email subject.

	Source of information:
		http://www.pmdcorp.com/
		(Programmer's Reference & User's Guide)

*/

/* Start: All Pilot Mition Processor are defined here */
#define ClearInterrupt 0xAC
#define AdjustActualPostion 0xF5
#define ClearPositionError 0x47
#define GetActivityStatus 0xA6
#define GetActualVelocity 0xAD
#define GetCaptureValue 0x36
#define GetChecksum 0xF8
#define GetCommandedAcceleration 0xA7
#define GetCommandedPostion 0x1D
#define GetCommandedVelocity 0x1E
#define GetCurrentMotorCommand 0x3A
#define GetDerivative 0x9B
#define GetEventStatus 0x31
#define GetHostIOError 0xA5
#define GetIntegral 0x9A
#define GetInterruptAxis 0xE1
#define GetPhaseCommand 0xEA
#define GetPositionError 0x99
#define GetSignalStatus 0xA4
#define GetTime 0x3E
#define GetTraceCount 0xBB
#define GetTraceStatus 0xBA
#define GetVersion 0x8F
#define InitializPhase 0x7A
#define NoOperation 0x00
#define ReadAnalog 0xEF
#define ReadBuffer 0xC9
#define ReadIO 0x83
#define Reset 0x39
#define ResetEventStatus 0x34
#define SetAcceleration 0x90
#define GetAcceleration 0x4C
#define SetActualPostion 0x4D
#define GetActualPostion 0x37
#define SetActualPostionUnits 0xBE
#define GetActualPostionUnits 0xBF
#define SetAutoStopMode 0xD2
#define GetAutoStopMode 0xD3
#define SetAxisMode 0x87
#define GetAxisMode 0x88
#define SetAxisOutSource 0xED
#define GetAxisOutSource 0xEE
#define SetBreakpoint 0xD4
#define GetBreakpoint 0xD5
#define SetBreakpointValue 0xD6
#define GetBreakpointValue 0xD7
#define SetBufferFunction 0xCA
#define GetBufferFunction 0xCB
#define SetbufferLength 0xC2
#define GetBufferLength 0xC3
#define SetBufferReadIndex 0xC6
#define GetBufferReadIndex 0xC7
#define SetBufferStart 0xC0
#define GetBufferStart 0xC1
#define SetBufferWriteIndex 0xC4
#define GetBufferWriteIndex 0xC5
#define SetCaptureSource 0xD8
#define GetCaptureSource 0xD9
#define SetCommutationMode 0xE2
#define GetCommutationMode 0xE3
#define SetDeceleration 0x91
#define GetDeceleration 0x92
#define SetDerivativeTime 0x9C
#define GetDerivativeTime 0x9D
#define SetDiagnosticPortMode 0x89
#define GetDiagnosticPortMode 0x8A
#define SetEncoderModulus 0x8D
#define GetEncoderModulus 0x8E
#define SetEncoderSource 0xDA
#define GetEncoderSource 0xDB
#define SetEncoderToStepRatio 0xDE
#define GetEncoderToStepRatio 0xDF
#define SetIntegrationLimit 0x95
#define GetIntegrationLimit 0x96
#define SetInterruptMask 0x2F
#define GetInterruptMask 0x56
#define SetJerk 0x13
#define GetJerk 0x58
#define SetKaff 0x93
#define GetKaff 0x94
#define SetKd 0x27
#define GetKd 0x52
#define SetKi 0x26
#define GetKi 0x51
#define SetKout 0x9E
#define GetKout 0x9F
#define SetKp 0x25
#define GetKp 0x50
#define SetKvff 0x2B
#define GetKvff 0x54
#define SetLimitSwitchMode 0x80
#define GetLimitSwitchMode 0x81
#define SetMotionCompleteMode 0xEB
#define GetMotionCompleteMode 0xEC
#define SetMotorBias 0x0F
#define GetMotorBias 0x2D
#define SetMotorCommand 0x77
#define GetMotorCommand 0x69
#define SetMotorLimit 0x06
#define GetMotorLimit 0x07
#define SetMotorMode 0xDC
#define GetMotorMode 0xDD
#define SetNumberPhases 0x85
#define GetNumberPhases 0x86
#define SetOutputMode 0xE0
#define GetOutputMode 0x6E
#define SetPhaseAngle 0x84
#define GetPhaseAngle 0x2C
#define SetPhaseCorrectionMode 0xE8
#define GetPhaseCorrectionMode 0xE9
#define SetPhaseCounts 0x75
#define GetPhaseCounts 0x7D
#define SetPhaseInitializeMode 0xE4
#define GetPhaseInitializeMode 0xE5
#define SetPhaseInitializeTime 0x72
#define GetPhaseInitializeTime 0x7C
#define SetPhaseOffset 0x76
#define GetPhaseOffset 0x7B
#define SetPhasePrescale 0xE6
#define GetPhasePrescale 0xE7
#define SetPostion 0x10
#define GetPostion 0x4A
#define SetPostionErrorLimit 0x97
#define GetPostionErrorLimit 0x98
#define SetProfileMode 0xA0
#define GetProfileMode 0xA1
#define SetSampleTime 0x38
#define GetSampleTime 0x61
#define SetSerialPortMode 0x8B
#define GetSerialPortMode 0x8C
#define SetSettleTime 0xAA
#define GetSettleTime 0xAB
#define SetSettleWindow 0xBC
#define GetSettleWindow 0xBD
#define SetSignalSense 0xA2
#define GetSignalSense 0xA3
#define SetStartMode 0xCC
#define GetStartMode 0xCD
#define SetStartVelocity 0x6A
#define GetStartVelocity 0x6B
#define SetStopMode 0xD0
#define GetStopMode 0xD1
#define SetSynchronizationMode 0xF2
#define GetSynchronizationMode 0xF3
#define SetTraceMode 0xB0
#define GetTraceMode 0xB1
#define SetTracePeriod 0xB8
#define GetTracePeriod 0xB9
#define SetTraceStart 0xB2
#define GetTraceStart 0xB3
#define SetTraceStop 0xB4
#define GetTraceStop 0xB5
#define SetTraceVariable 0xB6
#define GetTraceVariable 0xB7
#define SetTrackingWindow 0xA8
#define GetTrackingWindow 0xA9
#define SetVelocity 0x11
#define GetVelocity 0xAB
#define Update 0x1A
#define WriteBuffer 0xC8
#define WriteIO 0x82
/* End: All Pilot Mition Processor are defined here */
/* Begin: Function error code are defined here */
#define ERR_RCM_NO_ERROR 0
#define ERR_RCM_INVALID_PORT 1
#define ERR_RCM_OPENPORT 2
/* End: Function error code are defined here */
/* Begin: Define constant for PWDReply */
#define STATUS 0
#define CHECKSUM 1
#define DATA_START 2
#define DATA_END 7
#define CHECKSUMVALID 0
/* END: Define constant for PWDReply */
#define PWMREPLYSIZE 8

typedef struct PWDCmd_struct {
	byte address;
	byte checksum;
	byte axis;	// initialized by constructor, always 0
	byte code;
	byte data[6];
	byte size;	// meta data, should be not be send.
} PWDCmd;

typedef struct PWDReply_struct {
	byte data[PWMREPLYSIZE];

	DWORD dwSize;

	DWORD Status();
	// return 0(valid) if the valus is correct
	DWORD CheckChecksum();
	void PrintData();
} PWDReply;


class RCMotion
{
private:
	char cRCMCom[5];
	HANDLE hRCMCom;
	const static int nosend=0; // disable(1) from sending command the COM port
	const static int debug=0;  // enable(1) dumping of command sending to COM port

public:
	RCMotion(void);
	int RCMInit(char *ComPort);
	PWDCmd SetCmd(byte, byte);
	PWDCmd SetCmd(byte, byte, WORD);
	PWDCmd SetCmd(byte, byte, WORD, WORD);
	PWDReply SendCmd(PWDCmd *);
	// Processor command without paramters
	PWDReply SendCmd(byte, byte);
	// Processor command with only one parameter
	PWDReply SendCmd(byte, byte, WORD);
	// Processor command with two parameters
	PWDReply SendCmd(byte, byte, WORD, WORD);
	// Processor command with two parameters(represent by a double word)
	PWDReply SendCmd_DW(byte paddress, byte pcode, DWORD dwData);

	void WheelUpdate();
	void WheelSetPower(WORD);
	void WheelInit();
	void WheelSetVelocity(DWORD);
	void WheelSetTurn(DWORD);

	~RCMotion(void);
};
